Index: irmp.c
===================================================================
--- irmp.c	(Revision 191)
+++ irmp.c	(Arbeitskopie)
@@ -1,4 +1,6 @@
-/*---------------------------------------------------------------------------------------------------------------------------------------------------
+//#define __asm(...) (void) 0
+
+/*------------------------------------------------------------------------------
  * irmp.c - infrared multi-protocol decoder, supports several remote control protocols
  *
  * Copyright (c) 2009-2019 Frank Meyer - frank(at)fli4l.de
@@ -17,7 +19,7 @@
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
- *---------------------------------------------------------------------------------------------------------------------------------------------------
+ *------------------------------------------------------------------------------
  */
 
 #include "irmp.h"
@@ -808,7 +810,7 @@ irmp_protocol_names[IRMP_N_PROTOCOLS + 1
 #  if IRMP_EXT_LOGGING == 1                                             // use external logging
 #    include "irmpextlog.h"
 #  else                                                                 // normal UART log (IRMP_EXT_LOGGING == 0)
-#    define BAUD                                    9600L
+//#    define BAUD                                    9600L
 #  ifndef UNIX_OR_WINDOWS
 #    include <util/setbaud.h>
 #  endif
@@ -2292,23 +2294,62 @@ static const PROGMEM IRMP_PARAMETER radi
 
 #endif
 
-static uint_fast8_t                             irmp_bit;                   // current bit position
-static IRMP_PARAMETER                           irmp_param;
-
+typedef struct
+{
+    // Current bit position
+    uint_fast8_t   bit;
+    IRMP_PARAMETER param;
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1 && (IRMP_SUPPORT_FDC_PROTOCOL == 1 || IRMP_SUPPORT_RCCAR_PROTOCOL == 1)
-static IRMP_PARAMETER                           irmp_param2;
+    IRMP_PARAMETER param2;
 #endif
+    volatile uint_fast8_t  ir_detected;
+    volatile uint_fast8_t  protocol;
+    volatile uint_fast16_t address;
+#if IRMP_32_BIT == 1
+    volatile uint_fast32_t command;
+#else
+    volatile uint_fast16_t command;
+#endif
+    volatile uint_fast16_t id;      // Only used for SAMSUNG protocol.
+    volatile uint_fast8_t  flags;
 
-static volatile uint_fast8_t                    irmp_ir_detected = FALSE;
-static volatile uint_fast8_t                    irmp_protocol;
-static volatile uint_fast16_t                   irmp_address;
+    // These statics must not be volatile, because they are only used by
+    // irmp_store_bit(), which is called by irmp_ISR().
+    uint_fast16_t tmp_address;
 #if IRMP_32_BIT == 1
-static volatile uint_fast32_t                   irmp_command;
+    uint_fast32_t tmp_command;
 #else
-static volatile uint_fast16_t                   irmp_command;
+    uint_fast16_t tmp_command;
+#endif
+
+#if (IRMP_SUPPORT_RC5_PROTOCOL == 1 && (IRMP_SUPPORT_FDC_PROTOCOL == 1 || IRMP_SUPPORT_RCCAR_PROTOCOL == 1)) || IRMP_SUPPORT_NEC42_PROTOCOL == 1
+    uint_fast16_t tmp_address2;
+    uint_fast16_t tmp_command2;
+#endif
+
+#if IRMP_SUPPORT_LGAIR_PROTOCOL == 1
+    uint_fast16_t lgair_address;                            // ir address
+    uint_fast16_t lgair_command;                            // ir command
 #endif
-static volatile uint_fast16_t                   irmp_id;                // only used for SAMSUNG protocol
-static volatile uint_fast8_t                    irmp_flags;
+
+#if IRMP_SUPPORT_SAMSUNG_PROTOCOL == 1
+    uint_fast16_t tmp_id;                                   // ir id (only SAMSUNG)
+#endif
+
+    struct
+    {
+        uint_fast8_t     start_bit_detected;   // flag: start bit detected
+        uint_fast8_t     wait_for_space;       // flag: wait for data bit space
+        uint_fast8_t     wait_for_start_space; // flag: wait for start bit space
+        uint_fast8_t     pulse_time;           // count bit time for pulse
+        PAUSE_LEN        pause_time;           // count bit time for pause
+        uint_fast16_t    key_repetition_len;   // SIRCS repeats frame 2-5 times with 45 ms pause
+        uint_fast8_t     repetition_frame_number;
+    } isr;
+} irmp_t;
+
+static irmp_t irmp;
+
 // static volatile uint_fast8_t                 irmp_busy_flag;
 
 #if defined(__MBED__)
@@ -2368,8 +2409,8 @@ irmp_init (void)
     ROM_GPIOPadConfigSet(IRMP_PORT_BASE, IRMP_PORT_PIN, GPIO_STRENGTH_2MA, GPIO_PIN_TYPE_STD_WPU);
 
 #elif defined(__SDCC_stm8)                                              // STM8
-    IRMP_GPIO_STRUCT->DDR &= ~(1<<IRMP_BIT);                            // pin is input
-    IRMP_GPIO_STRUCT->CR1 |= (1<<IRMP_BIT);                             // activate pullup
+    IRMP_GPIO_STRUCT->DDR &= ~(1 << IRMP_BIT);                            // pin is input
+    IRMP_GPIO_STRUCT->CR1 |= (1 << IRMP_BIT);                             // activate pullup
 
 #elif defined (TEENSY_ARM_CORTEX_M4)                                    // TEENSY
     pinMode(IRMP_PIN, INPUT);
@@ -2394,8 +2435,8 @@ irmp_init (void)
     // ChibiOS HAL automatically initializes all pins according to the board config file, no need to repeat here
 
 #else                                                                   // AVR
-    IRMP_PORT &= ~(1<<IRMP_BIT);                                        // deactivate pullup
-    IRMP_DDR &= ~(1<<IRMP_BIT);                                         // set pin to input
+    IRMP_PORT &= ~(1 << IRMP_BIT);                                        // deactivate pullup
+    IRMP_DDR &= ~(1 << IRMP_BIT);                                         // set pin to input
 #endif
 
 #if IRMP_LOGGING == 1
@@ -2413,28 +2454,31 @@ irmp_init (void)
 uint_fast8_t
 irmp_get_data (IRMP_DATA * irmp_data_p)
 {
+    irmp_t *ir = &irmp;
+    __asm ("" : "+r" (ir));
+
     uint_fast8_t   rtc = FALSE;
 #if IRMP_SUPPORT_MERLIN_PROTOCOL == 1
     uint_fast8_t   cmd_len = 0;
 #endif
 
-    if (irmp_ir_detected)
+    if (ir->ir_detected)
     {
-        switch (irmp_protocol)
+        switch (ir->protocol)
         {
 #if IRMP_SUPPORT_SAMSUNG_PROTOCOL == 1
             case IRMP_SAMSUNG_PROTOCOL:
-                if ((irmp_command >> 8) == (~irmp_command & 0x00FF))
+                if ((ir->command >> 8) == (~ir->command & 0x00FF))
                 {
-                    irmp_command &= 0xff;
-                    irmp_command |= irmp_id << 8;
+                    ir->command &= 0xff;
+                    ir->command |= ir->id << 8;
                     rtc = TRUE;
                 }
                 break;
 
 #if IRMP_SUPPORT_SAMSUNG48_PROTOCOL == 1
             case IRMP_SAMSUNG48_PROTOCOL:
-                irmp_command = (irmp_command & 0x00FF) | ((irmp_id & 0x00FF) << 8);
+                ir->command = (ir->command & 0x00FF) | ((ir->id & 0x00FF) << 8);
                 rtc = TRUE;
                 break;
 #endif
@@ -2442,19 +2486,19 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
 
 #if IRMP_SUPPORT_NEC_PROTOCOL == 1
             case IRMP_NEC_PROTOCOL:
-                if ((irmp_command >> 8) == (~irmp_command & 0x00FF))
+                if ((ir->command >> 8) == (~ir->command & 0x00FF))
                 {
-                    irmp_command &= 0xff;
+                    ir->command &= 0xff;
                     rtc = TRUE;
                 }
-                else if (irmp_address == 0x87EE)
+                else if (ir->address == 0x87EE)
                 {
 #ifdef ANALYZE
                     ANALYZE_PRINTF ("Switching to APPLE protocol\n");
 #endif // ANALYZE
-                    irmp_protocol = IRMP_APPLE_PROTOCOL;
-                    irmp_address = (irmp_command & 0xFF00) >> 8;
-                    irmp_command &= 0x00FF;
+                    ir->protocol = IRMP_APPLE_PROTOCOL;
+                    ir->address = (ir->command & 0xFF00) >> 8;
+                    ir->command &= 0x00FF;
                     rtc = TRUE;
                 }
                 else
@@ -2462,7 +2506,7 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
 #ifdef ANALYZE
                     ANALYZE_PRINTF ("Switching to ONKYO protocol\n");
 #endif // ANALYZE
-                    irmp_protocol = IRMP_ONKYO_PROTOCOL;
+                    ir->protocol = IRMP_ONKYO_PROTOCOL;
                     rtc = TRUE;
                 }
                 break;
@@ -2471,9 +2515,9 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
 
 #if IRMP_SUPPORT_NEC_PROTOCOL == 1
             case IRMP_VINCENT_PROTOCOL:
-                if ((irmp_command >> 8) == (irmp_command & 0x00FF))
+                if ((ir->command >> 8) == (ir->command & 0x00FF))
                 {
-                    irmp_command &= 0xff;
+                    ir->command &= 0xff;
                     rtc = TRUE;
                 }
                 break;
@@ -2481,9 +2525,9 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
 
 #if IRMP_SUPPORT_BOSE_PROTOCOL == 1
             case IRMP_BOSE_PROTOCOL:
-                if ((irmp_command >> 8) == (~irmp_command & 0x00FF))
+                if ((ir->command >> 8) == (~ir->command & 0x00FF))
                 {
-                    irmp_command &= 0xff;
+                    ir->command &= 0xff;
                     rtc = TRUE;
                 }
                 break;
@@ -2491,18 +2535,18 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
 
 #if IRMP_SUPPORT_MERLIN_PROTOCOL == 1
             case IRMP_MERLIN_PROTOCOL:
-                if (irmp_bit == 10)
+                if (ir->bit == 10)
                 {
                     rtc = TRUE;
                 }
-                else if (irmp_bit >= 19 && ((irmp_bit - 3) % 8 == 0))
+                else if (ir->bit >= 19 && ((ir->bit - 3) % 8 == 0))
                 {
-                    if (((irmp_command >> 1) & 1) != (irmp_command & 1))
+                    if (((ir->command >> 1) & 1) != (ir->command & 1))
                     {
-                        irmp_command >>= 1;
-                        irmp_command |= ((irmp_address & 1) << (irmp_bit - 12));
-                        irmp_address >>= 1;
-                        cmd_len = (irmp_bit - 11) >> 3;
+                        ir->command >>= 1;
+                        ir->command |= ((ir->address & 1) << (ir->bit - 12));
+                        ir->address >>= 1;
+                        cmd_len = (ir->bit - 11) >> 3;
                         rtc = TRUE;
                     }
                 }
@@ -2512,16 +2556,16 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
 #if IRMP_SUPPORT_SIEMENS_OR_RUWIDO_PROTOCOL == 1
             case IRMP_SIEMENS_PROTOCOL:
             case IRMP_RUWIDO_PROTOCOL:
-                if (((irmp_command >> 1) & 0x0001) == (~irmp_command & 0x0001))
+                if (((ir->command >> 1) & 0x0001) == (~ir->command & 0x0001))
                 {
-                    irmp_command >>= 1;
+                    ir->command >>= 1;
                     rtc = TRUE;
                 }
                 break;
 #endif
 #if IRMP_SUPPORT_KATHREIN_PROTOCOL == 1
             case IRMP_KATHREIN_PROTOCOL:
-                if (irmp_command != 0x0000)
+                if (ir->command != 0x0000)
                 {
                     rtc = TRUE;
                 }
@@ -2529,19 +2573,19 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
 #endif
 #if IRMP_SUPPORT_RC5_PROTOCOL == 1
             case IRMP_RC5_PROTOCOL:
-                irmp_address &= ~0x20;                              // clear toggle bit
+                ir->address &= ~0x20;                              // clear toggle bit
                 rtc = TRUE;
                 break;
 #endif
 #if IRMP_SUPPORT_S100_PROTOCOL == 1
             case IRMP_S100_PROTOCOL:
-                irmp_address &= ~0x20;                              // clear toggle bit
+                ir->address &= ~0x20;                              // clear toggle bit
                 rtc = TRUE;
                 break;
 #endif
 #if IRMP_SUPPORT_IR60_PROTOCOL == 1
             case IRMP_IR60_PROTOCOL:
-                if (irmp_command != 0x007d)                         // 0x007d (== 62<<1 + 1) is start instruction frame
+                if (ir->command != 0x007d)                         // 0x007d (== 62<<1 + 1) is start instruction frame
                 {
                     rtc = TRUE;
                 }
@@ -2558,28 +2602,28 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
                 // frame in irmp_data:
                 // Bit 12 11 10 9  8  7  6  5  4  3  2  1  0
                 //     V  D7 D6 D5 D4 D3 D2 D1 D0 A1 A0 C1 C0   //         10 9  8  7  6  5  4  3  2  1  0
-                irmp_address = (irmp_command & 0x000C) >> 2;    // addr:   0  0  0  0  0  0  0  0  0  A1 A0
-                irmp_command = ((irmp_command & 0x1000) >> 2) | // V-Bit:  V  0  0  0  0  0  0  0  0  0  0
-                               ((irmp_command & 0x0003) << 8) | // C-Bits: 0  C1 C0 0  0  0  0  0  0  0  0
-                               ((irmp_command & 0x0FF0) >> 4);  // D-Bits:          D7 D6 D5 D4 D3 D2 D1 D0
+                ir->address = (ir->command & 0x000C) >> 2;    // addr:   0  0  0  0  0  0  0  0  0  A1 A0
+                ir->command = ((ir->command & 0x1000) >> 2) | // V-Bit:  V  0  0  0  0  0  0  0  0  0  0
+                               ((ir->command & 0x0003) << 8) | // C-Bits: 0  C1 C0 0  0  0  0  0  0  0  0
+                               ((ir->command & 0x0FF0) >> 4);  // D-Bits:          D7 D6 D5 D4 D3 D2 D1 D0
                 rtc = TRUE;                                     // Summe:  V  C1 C0 D7 D6 D5 D4 D3 D2 D1 D0
                 break;
 #endif
 
 #if IRMP_SUPPORT_NETBOX_PROTOCOL == 1                           // squeeze code to 8 bit, upper bit indicates release-key
             case IRMP_NETBOX_PROTOCOL:
-                if (irmp_command & 0x1000)                      // last bit set?
+                if (ir->command & 0x1000)                      // last bit set?
                 {
-                    if ((irmp_command & 0x1f) == 0x15)          // key pressed: 101 01 (LSB)
+                    if ((ir->command & 0x1f) == 0x15)          // key pressed: 101 01 (LSB)
                     {
-                        irmp_command >>= 5;
-                        irmp_command &= 0x7F;
+                        ir->command >>= 5;
+                        ir->command &= 0x7F;
                         rtc = TRUE;
                     }
-                    else if ((irmp_command & 0x1f) == 0x10)     // key released: 000 01 (LSB)
+                    else if ((ir->command & 0x1f) == 0x10)     // key released: 000 01 (LSB)
                     {
-                        irmp_command >>= 5;
-                        irmp_command |= 0x80;
+                        ir->command >>= 5;
+                        ir->command |= 0x80;
                         rtc = TRUE;
                     }
                     else
@@ -2600,11 +2644,11 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
 #if IRMP_SUPPORT_LEGO_PROTOCOL == 1
             case IRMP_LEGO_PROTOCOL:
             {
-                uint_fast8_t crc = 0x0F ^ ((irmp_command & 0xF000) >> 12) ^ ((irmp_command & 0x0F00) >> 8) ^ ((irmp_command & 0x00F0) >> 4);
+                uint_fast8_t crc = 0x0F ^ ((ir->command & 0xF000) >> 12) ^ ((ir->command & 0x0F00) >> 8) ^ ((ir->command & 0x00F0) >> 4);
 
-                if ((irmp_command & 0x000F) == crc)
+                if ((ir->command & 0x000F) == crc)
                 {
-                    irmp_command >>= 4;
+                    ir->command >>= 4;
                     rtc = TRUE;
                 }
                 else
@@ -2620,11 +2664,11 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
 
 #if IRMP_SUPPORT_METZ_PROTOCOL == 1
             case IRMP_METZ_PROTOCOL:
-                irmp_address &= ~0x40;                              // clear toggle bit
-                if (((~irmp_address) & 0x07) == (irmp_address >> 3) && ((~irmp_command) & 0x3f) == (irmp_command >> 6))
+                ir->address &= ~0x40;                              // clear toggle bit
+                if (((~ir->address) & 0x07) == (ir->address >> 3) && ((~ir->command) & 0x3f) == (ir->command >> 6))
                 {
-                    irmp_address >>= 3;
-                    irmp_command >>= 6;
+                    ir->address >>= 3;
+                    ir->command >>= 6;
                     rtc = TRUE;
                 }
                 break;
@@ -2638,24 +2682,24 @@ irmp_get_data (IRMP_DATA * irmp_data_p)
 
         if (rtc)
         {
-            irmp_data_p->protocol = irmp_protocol;
-            irmp_data_p->address  = irmp_address;
-            irmp_data_p->command  = irmp_command;
-            irmp_data_p->flags    = irmp_flags;
+            irmp_data_p->protocol = ir->protocol;
+            irmp_data_p->address  = ir->address;
+            irmp_data_p->command  = ir->command;
+            irmp_data_p->flags    = ir->flags;
 #if IRMP_SUPPORT_MERLIN_PROTOCOL == 1
             irmp_data_p->flags   |= cmd_len;
 #endif
         }
         else
         {
-            irmp_protocol = IRMP_UNKNOWN_PROTOCOL;
+            ir->protocol = IRMP_UNKNOWN_PROTOCOL;
         }
 
-        irmp_command  = 0;                                      // don't reset irmp_protocol here, needed for detection of NEC & JVC repetition frames!
-        irmp_address  = 0;
-        irmp_flags    = 0;
+        ir->command  = 0;                                      // don't reset ir->protocol here, needed for detection of NEC & JVC repetition frames!
+        ir->address  = 0;
+        ir->flags    = 0;
 
-        irmp_ir_detected = FALSE;
+        ir->ir_detected = FALSE;
     }
 
     return rtc;
@@ -2669,27 +2713,6 @@ irmp_set_callback_ptr (void (*cb)(uint_f
 }
 #endif // IRMP_USE_CALLBACK == 1
 
-// these statics must not be volatile, because they are only used by irmp_store_bit(), which is called by irmp_ISR()
-static uint_fast16_t irmp_tmp_address;                                      // ir address
-#if IRMP_32_BIT == 1
-static uint_fast32_t irmp_tmp_command;                                      // ir command
-#else
-static uint_fast16_t irmp_tmp_command;                                      // ir command
-#endif
-
-#if (IRMP_SUPPORT_RC5_PROTOCOL == 1 && (IRMP_SUPPORT_FDC_PROTOCOL == 1 || IRMP_SUPPORT_RCCAR_PROTOCOL == 1)) || IRMP_SUPPORT_NEC42_PROTOCOL == 1
-static uint_fast16_t irmp_tmp_address2;                                     // ir address
-static uint_fast16_t irmp_tmp_command2;                                     // ir command
-#endif
-
-#if IRMP_SUPPORT_LGAIR_PROTOCOL == 1
-static uint_fast16_t irmp_lgair_address;                                    // ir address
-static uint_fast16_t irmp_lgair_command;                                    // ir command
-#endif
-
-#if IRMP_SUPPORT_SAMSUNG_PROTOCOL == 1
-static uint_fast16_t irmp_tmp_id;                                           // ir id (only SAMSUNG)
-#endif
 #if IRMP_SUPPORT_KASEIKYO_PROTOCOL == 1
 static uint8_t      xor_check[6];                                           // check kaseikyo "parity" bits
 static uint_fast8_t genre2;                                                 // save genre2 bits here, later copied to MSB in flags
@@ -2716,8 +2739,11 @@ static uint_fast8_t  mitsu_parity;      
 static void
 irmp_store_bit (uint_fast8_t value)
 {
+    irmp_t *ir = &irmp;
+    __asm ("" : "+r" (ir));
+
 #if IRMP_SUPPORT_ACP24_PROTOCOL == 1
-    if (irmp_param.protocol == IRMP_ACP24_PROTOCOL)                                                 // squeeze 64 bits into 16 bits:
+    if (ir->param.protocol == IRMP_ACP24_PROTOCOL)                                                 // squeeze 64 bits into 16 bits:
     {
         if (value)
         {
@@ -2731,24 +2757,24 @@ irmp_store_bit (uint_fast8_t value)
             //         5432109876543210
             //         NAVVvMMMmtxyTTTT
 
-            switch (irmp_bit)
+            switch (ir->bit)
             {
-                case  0: irmp_tmp_command |= (1<<15); break;                                        // N
-                case  2: irmp_tmp_command |= (1<<13); break;                                        // V
-                case  3: irmp_tmp_command |= (1<<12); break;                                        // V
-                case  4: irmp_tmp_command |= (1<<10); break;                                        // M
-                case  5: irmp_tmp_command |= (1<< 9); break;                                        // M
-                case  6: irmp_tmp_command |= (1<< 8); break;                                        // M
-                case 20: irmp_tmp_command |= (1<< 6); break;                                        // t
-                case 22: irmp_tmp_command |= (1<<11); break;                                        // v
-                case 23: irmp_tmp_command |= (1<< 7); break;                                        // m
-                case 24: irmp_tmp_command |= (1<<14); break;                                        // A
-                case 26: irmp_tmp_command |= (1<< 5); break;                                        // x
-                case 44: irmp_tmp_command |= (1<< 4); break;                                        // y
-                case 66: irmp_tmp_command |= (1<< 3); break;                                        // T
-                case 67: irmp_tmp_command |= (1<< 2); break;                                        // T
-                case 68: irmp_tmp_command |= (1<< 1); break;                                        // T
-                case 69: irmp_tmp_command |= (1<< 0); break;                                        // T
+                case  0: ir->tmp_command |= (1 << 15); break;             // N
+                case  2: ir->tmp_command |= (1 << 13); break;             // V
+                case  3: ir->tmp_command |= (1 << 12); break;             // V
+                case  4: ir->tmp_command |= (1 << 10); break;             // M
+                case  5: ir->tmp_command |= (1 <<  9); break;             // M
+                case  6: ir->tmp_command |= (1 <<  8); break;             // M
+                case 20: ir->tmp_command |= (1 <<  6); break;             // t
+                case 22: ir->tmp_command |= (1 << 11); break;             // v
+                case 23: ir->tmp_command |= (1 <<  7); break;             // m
+                case 24: ir->tmp_command |= (1 << 14); break;             // A
+                case 26: ir->tmp_command |= (1 <<  5); break;             // x
+                case 44: ir->tmp_command |= (1 <<  4); break;             // y
+                case 66: ir->tmp_command |= (1 <<  3); break;             // T
+                case 67: ir->tmp_command |= (1 <<  2); break;             // T
+                case 68: ir->tmp_command |= (1 <<  1); break;             // T
+                case 69: ir->tmp_command |= (1 <<  0); break;             // T
             }
         }
     }
@@ -2756,18 +2782,18 @@ irmp_store_bit (uint_fast8_t value)
 #endif // IRMP_SUPPORT_ACP24_PROTOCOL
 
 #if IRMP_SUPPORT_ORTEK_PROTOCOL == 1
-    if (irmp_param.protocol == IRMP_ORTEK_PROTOCOL)
+    if (ir->param.protocol == IRMP_ORTEK_PROTOCOL)
     {
-        if (irmp_bit < 14)
+        if (ir->bit < 14)
         {
             if (value)
             {
                 parity++;
             }
         }
-        else if (irmp_bit == 14)
+        else if (ir->bit == 14)
         {
-            if (value)                                                                                      // value == 1: even parity
+            if (value)                               // value == 1: even parity
             {
                 if (parity & 0x01)
                 {
@@ -2780,7 +2806,7 @@ irmp_store_bit (uint_fast8_t value)
             }
             else
             {
-                if (parity & 0x01)                                                                          // value == 0: odd parity
+                if (parity & 0x01)                   // value == 0: odd parity
                 {
                     parity = PARITY_CHECK_OK;
                 }
@@ -2798,101 +2824,101 @@ irmp_store_bit (uint_fast8_t value)
     }
 
 #if IRMP_SUPPORT_GRUNDIG_NOKIA_IR60_PROTOCOL == 1
-    if (irmp_bit == 0 && irmp_param.protocol == IRMP_GRUNDIG_PROTOCOL)
+    if (ir->bit == 0 && ir->param.protocol == IRMP_GRUNDIG_PROTOCOL)
     {
         first_bit = value;
     }
     else
 #endif
 
-    if (irmp_bit >= irmp_param.address_offset && irmp_bit < irmp_param.address_end)
+    if (ir->bit >= ir->param.address_offset && ir->bit < ir->param.address_end)
     {
-        if (irmp_param.lsb_first)
+        if (ir->param.lsb_first)
         {
-            irmp_tmp_address |= (((uint_fast16_t) (value)) << (irmp_bit - irmp_param.address_offset));   // CV wants cast
+            ir->tmp_address |= (((uint_fast16_t) (value)) << (ir->bit - ir->param.address_offset));   // CV wants cast
         }
         else
         {
-            irmp_tmp_address <<= 1;
-            irmp_tmp_address |= value;
+            ir->tmp_address <<= 1;
+            ir->tmp_address |= value;
         }
     }
-    else if (irmp_bit >= irmp_param.command_offset && irmp_bit < irmp_param.command_end)
+    else if (ir->bit >= ir->param.command_offset && ir->bit < ir->param.command_end)
     {
-        if (irmp_param.lsb_first)
+        if (ir->param.lsb_first)
         {
 #if IRMP_SUPPORT_SAMSUNG48_PROTOCOL == 1
-            if (irmp_param.protocol == IRMP_SAMSUNG48_PROTOCOL && irmp_bit >= 32)
+            if (ir->param.protocol == IRMP_SAMSUNG48_PROTOCOL && ir->bit >= 32)
             {
-                irmp_tmp_id |= (((uint_fast16_t) (value)) << (irmp_bit - 32));   // CV wants cast
+                ir->tmp_id |= (((uint_fast16_t) (value)) << (ir->bit - 32));   // CV wants cast
             }
             else
 #endif
             {
-                irmp_tmp_command |= (((uint_fast16_t) (value)) << (irmp_bit - irmp_param.command_offset));   // CV wants cast
+                ir->tmp_command |= (((uint_fast16_t) (value)) << (ir->bit - ir->param.command_offset));   // CV wants cast
             }
         }
         else
         {
-            irmp_tmp_command <<= 1;
-            irmp_tmp_command |= value;
+            ir->tmp_command <<= 1;
+            ir->tmp_command |= value;
         }
     }
 
 #if IRMP_SUPPORT_LGAIR_PROTOCOL == 1
-    if (irmp_param.protocol == IRMP_NEC_PROTOCOL || irmp_param.protocol == IRMP_NEC42_PROTOCOL)
+    if (ir->param.protocol == IRMP_NEC_PROTOCOL || ir->param.protocol == IRMP_NEC42_PROTOCOL)
     {
-        if (irmp_bit < 8)
+        if (ir->bit < 8)
         {
-            irmp_lgair_address <<= 1;                                                               // LGAIR uses MSB
-            irmp_lgair_address |= value;
+            ir->lgair_address <<= 1;                                                               // LGAIR uses MSB
+            ir->lgair_address |= value;
         }
-        else if (irmp_bit < 24)
+        else if (ir->bit < 24)
         {
-            irmp_lgair_command <<= 1;                                                               // LGAIR uses MSB
-            irmp_lgair_command |= value;
+            ir->lgair_command <<= 1;                                                               // LGAIR uses MSB
+            ir->lgair_command |= value;
         }
     }
     // NO else!
 #endif
 
 #if IRMP_SUPPORT_NEC42_PROTOCOL == 1
-    if (irmp_param.protocol == IRMP_NEC42_PROTOCOL && irmp_bit >= 13 && irmp_bit < 26)
+    if (ir->param.protocol == IRMP_NEC42_PROTOCOL && ir->bit >= 13 && ir->bit < 26)
     {
-        irmp_tmp_address2 |= (((uint_fast16_t) (value)) << (irmp_bit - 13));                             // CV wants cast
+        ir->tmp_address2 |= (((uint_fast16_t) (value)) << (ir->bit - 13));                             // CV wants cast
     }
     else
 #endif
 
 #if IRMP_SUPPORT_SAMSUNG_PROTOCOL == 1
-    if (irmp_param.protocol == IRMP_SAMSUNG_PROTOCOL && irmp_bit >= SAMSUNG_ID_OFFSET && irmp_bit < SAMSUNG_ID_OFFSET + SAMSUNG_ID_LEN)
+    if (ir->param.protocol == IRMP_SAMSUNG_PROTOCOL && ir->bit >= SAMSUNG_ID_OFFSET && ir->bit < SAMSUNG_ID_OFFSET + SAMSUNG_ID_LEN)
     {
-        irmp_tmp_id |= (((uint_fast16_t) (value)) << (irmp_bit - SAMSUNG_ID_OFFSET));                    // store with LSB first
+        ir->tmp_id |= (((uint_fast16_t) (value)) << (ir->bit - SAMSUNG_ID_OFFSET));                    // store with LSB first
     }
     else
 #endif
 
 #if IRMP_SUPPORT_KASEIKYO_PROTOCOL == 1
-    if (irmp_param.protocol == IRMP_KASEIKYO_PROTOCOL)
+    if (ir->param.protocol == IRMP_KASEIKYO_PROTOCOL)
     {
-        if (irmp_bit >= 20 && irmp_bit < 24)
+        if (ir->bit >= 20 && ir->bit < 24)
         {
-            irmp_tmp_command |= (((uint_fast16_t) (value)) << (irmp_bit - 8));      // store 4 system bits (genre 1) in upper nibble with LSB first
+            ir->tmp_command |= (((uint_fast16_t) (value)) << (ir->bit - 8));      // store 4 system bits (genre 1) in upper nibble with LSB first
         }
-        else if (irmp_bit >= 24 && irmp_bit < 28)
+        else if (ir->bit >= 24 && ir->bit < 28)
         {
-            genre2 |= (((uint_fast8_t) (value)) << (irmp_bit - 20));                // store 4 system bits (genre 2) in upper nibble with LSB first
+            genre2 |= (((uint_fast8_t) (value)) << (ir->bit - 20));                // store 4 system bits (genre 2) in upper nibble with LSB first
         }
 
-        if (irmp_bit < KASEIKYO_COMPLETE_DATA_LEN)
+        if (ir->bit < KASEIKYO_COMPLETE_DATA_LEN)
         {
             if (value)
             {
-                xor_check[irmp_bit / 8] |= 1 << (irmp_bit % 8);
+                xor_check[ir->bit / 8] |= 1 << (ir->bit % 8);
             }
             else
             {
-                xor_check[irmp_bit / 8] &= ~(1 << (irmp_bit % 8));
+                xor_check[ir->bit / 8] &= ~(1 << (ir->bit % 8));
             }
         }
     }
